// solution in O(abq) time
#include <bits/stdc++.h>
using namespace std;

unordered_map<long long, vector<int> > answers;

void solve(int a, int b, int c, queue<long long> &Q) {
    long long where = 0;
    for (int s=0; s<a+b+c-2; ++s) {
        int ilo = max(0,s-(b-1)-(c-1)), ihi = min(s,a-1);
        for (int i=ilo; i<=ihi; ++i) {
            int t = s - i;
            int jlo = max(0,t-(c-1)), jhi = min(t,b-1);
            for (int j=jlo; j<=jhi; ++j) {
                int k = t - j;
                ++where;
                if (where == Q.front()) {
                    answers[where] = {i,j,k};
                    Q.pop();
                    if (Q.empty()) return;
                }
            }
        }
    }
}

int main() {
    int a, b, c, q; cin >> a >> b >> c >> q;
    vector<long long> queries(q);
    for (int i=0; i<q; ++i) cin >> queries[i];
    queue<long long> Q;
    {
        set<long long> squeries( queries.begin(), queries.end() );
        for (long long x : squeries) Q.push(x);
    }
    solve(a,b,c,Q);
    for (int i=0; i<q; ++i) {
        auto tmp = answers[queries[i]];
        cout << tmp[0] << " " << tmp[1] << " " << tmp[2] << "\n";
    }
}
