// riesenie v O(q(s+a))
#include <bits/stdc++.h>
using namespace std;

long long obsah_rezu(long long a, long long b, long long c, long long s) {
    // kolko ma kvader policok (i,j,k) takych ze i+j+k = s?
    // zaratame vsetky trojice s i,j,k >= 0
    long long odpoved = (s+1)*(s+2)/2;
    // odratame vsetky kde je nejaka suradnica privelka
    if (s >= a) odpoved -= (s-a+1)*(s-a+2)/2;
    if (s >= b) odpoved -= (s-b+1)*(s-b+2)/2;
    if (s >= c) odpoved -= (s-c+1)*(s-c+2)/2;
    // dvakrat sme odratali tie, kde su dve privelke
    if (s >= a+b) odpoved += (s-a-b+1)*(s-a-b+2)/2;
    if (s >= a+c) odpoved += (s-a-c+1)*(s-a-c+2)/2;
    if (s >= b+c) odpoved += (s-b-c+1)*(s-b-c+2)/2;
    return odpoved;
}

long long obsah_uhlopriecky(long long b, long long c, long long s) {
    // kolko ma obdlznik policok (j,k) takych ze j+k = s?
    long long odpoved = s + 1;
    if (s >= b) odpoved -= (s - b + 1);
    if (s >= c) odpoved -= (s - c + 1);
    return odpoved;
}

int main() {
    long long a, b, c, q; cin >> a >> b >> c >> q;
    while (q--) {
        long long n; cin >> n;
        // najdi, v ktorom reze sme
        long long s = 0;
        while (true) {
            long long ob = obsah_rezu(a,b,c,s);
            if (ob < n) { n -= ob; ++s; } else break;
        }
        long long i = max(0LL, s - (b-1) - (c-1));
        while (true) {
            long long ob = obsah_uhlopriecky(b,c,s-i);
            if (ob < n) { n -= ob; ++i; } else break;
        }
        long long jmin = max(0LL, s - i - (c-1));
        long long j = jmin + (n-1);
        long long k = s - i - j;
        cout << i << " " << j << " " << k << endl;
    }
}
